/******************************************************************************
 * ASP DIGITAL (c) 2006
 * All rights reserved.
 *
 * Graphic LCD driver
 * Filename: display.h
 *
 * Display Control.
 *
 * Created 2 Aug 2006
 * revision: 6 Aug 2006: add prototypes.
 * 08 Aug 2006: add CopyLine()
 *  Add charloc_tp.
 *  WriteChar now accepts character location, not pixel location.
 ****************************************************************************/
#include <C8051F340.h>

/*
 * absolute location of any pixel on the display, with (0,0) being the upper
 * right corner.
 */
typedef struct _pixel_tp
{
	unsigned int x;
	unsigned int y;
} pixel_tp;

/*
 * location of a character on the display, in terms of character size (8 x 8).
 */
typedef struct _charloc_tp
{
    unsigned char x;
    unsigned char y;
} charloc_tp;

typedef enum _direction
{
	DIR_RIGHT = 0,
	DIR_DOWN = 1,
	DIR_LEFT = 2,
	DIR_UP = 3
} direction_tp;

typedef enum _extents
{
    XMIN = 0,
    XMAX = 479,
    YMIN = 0,
    YMAX = 127,
    CHARXMIN = XMIN / 8,
    CHARXMAX = XMAX / 8,
    CHARYMIN = YMIN / 8,
    CHARYMAX = YMAX / 8
} extents_tp;

void GLCD_ClearMemory(void);
unsigned int GLCD_CalcAddress(pixel_tp Cursor);

void GLCD_WriteByte(pixel_tp Cursor, unsigned char ByteData);
unsigned char GLCD_ReadByte(pixel_tp Cursor);
void GLCD_WritePixel(pixel_tp Cursor, bit Pixel);
void GLCD_CharLocToPixLoc(charloc_tp *ct, pixel_tp *pt);
void GLCD_LineCharToCharLoc(unsigned char linesel, unsigned char charsel, charloc_tp *ct);
void GLCD_LineCharToPixel(unsigned char linesel, unsigned char charsel, pixel_tp *pt);
void GLCD_WriteChar(charloc_tp CharLoc, unsigned char CharSel);
void GLCD_ShiftLinesUp(unsigned char srcoffset);

