/******************************************************************************
 * ASP DIGITAL (c) 2006
 * All rights reserved.
 *
 * Handle keypress info.
 * Filename: keypress.c
 *
 * The PS/2 keyboard interface in the FPGA sends us scancodes over the SPI. 
 * What we do here is capture all of the keypresses, and convert to ASCII. 
 * 
 * When a key is pressed, the keyboard will send a specific Make code, and 
 * when the key is released, the keyboard will send a specific Break code.
 * 
 * Before attempting to read the keyboard, call KP_Init().  This initializes
 * the various local variables and enables the SPI interrupt (we get scan
 * codes over SPI). 
 *
 * So, whenever we get a new scan code, the ISR calls KP_NewCode() with the
 * scancode as the parameter.  We test to see if we've got a break code.  If
 * we did, then we set the GotBreak bit so when the next code comes in, we 
 * know which key was released.  
 * If we didn't receive a break code, then we test to see if we've got an
 * extended key press, and we set ExtKey if true. 
 * If we didn't receive an F0 for extended key, then the next code is the key
 * that was pressed.  This could be a character key, or something like CTRL,
 * ALT, etc.
 * Created 31 Jul 2006
 * revision:
 ****************************************************************************/
#include "keypress.h"

void KP_Init(void)
{
